Subject: Re: [REGRESSION] Warning in tcp_fastretrans_alert() of net/ipv4/tcp_input.c

From: Oleksandr Natalenko <[email-masked]>
Date: Fri, 15 Sep 2017 07:03:26 +0200

Hi.

I've applied your test patch but it doesn't fix the issue for me since the 
warning is still there.

Were you able to reproduce it?

On pondělí 11. září 2017 1:59:02 CEST Neal Cardwell wrote:
> Thanks for the detailed report!
> 
> I suspect this is due to the following commit, which happened between
> 4.10 and 4.11:
> 
>   89fe18e44f7e tcp: extend F-RTO to catch more spurious timeouts
>  
> https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git/commit/?
> id=89fe18e44f7e
> 
> This commit expanded the set of scenarios where we would undo a
> CA_Loss cwnd reduction and return to TCP_CA_Open, but did not include
> a check to see if there were any in-flight retransmissions. I think we
> need a fix like the following:
> 
> diff --git a/net/ipv4/tcp_input.c b/net/ipv4/tcp_input.c
> index 659d1baefb2b..730a2de9d2b0 100644
> --- a/net/ipv4/tcp_input.c
> +++ b/net/ipv4/tcp_input.c
> @@ -2439,7 +2439,7 @@ static bool tcp_try_undo_loss(struct sock *sk,
> bool frto_undo)
>  {
>         struct tcp_sock *tp = tcp_sk(sk);
> 
> -       if (frto_undo || tcp_may_undo(tp)) {
> +       if ((frto_undo || tcp_may_undo(tp)) && !tp->retrans_out) {
>                 tcp_undo_cwnd_reduction(sk, true);
> 
>                 DBGUNDO(sk, "partial loss");
> 
> I will try a packetdrill test to see if I can reproduce this issue and
> verify the fix.
> 
> thanks,
> neal